--[[
File: Utility.lua
Author: Zormus
--]]

Library[(...).identifier].Utility = Library[(...).identifier].Utility or setmetatable({}, {__index = Utility})
local Utility = Library[(...).identifier].Utility

function Utility.SetDefaultValues(object, default)
	for key, value in pairs(default) do
		if Utility.Type(value) == "table" then
			object[key] = object[key] or {}
			Utility.SetDefaultValues(object[key], value)
		else
			if object[key] == nil then
				object[key] = value
			end
		end
	end
end

function Utility.Message(type, ...)
	local consoles = Inspect.Console.Detail(Inspect.Console.List())
	for id, console in pairs(consoles) do
		if console[type] then
			Command.Console.Display(id, ...)
		end
	end
end
